package at.jku.ssw.graphviz;

import at.jku.ssw.redblacktree.RedBlackTreeNode;

/**
 * A maker of dot strings for GraphViz in order to display data structures.
 */
public class DotMakerRB {

	private int cnt;

	/**
	 * Creates a dot string for a binary tree.
	 */
	public static String makeDot(RedBlackTreeNode root, RedBlackTreeNode nil) {
		if (root.left != nil)
			return new DotMakerRB().createGraph(root.left, nil);
		else
			return new DotMakerRB().createGraph(root.right, nil);
	}

	private String createGraph(RedBlackTreeNode root, RedBlackTreeNode nil) {
		StringBuilder b = new StringBuilder();
		b.append("digraph TreeRB {\n");
		cnt = 0;
		if (root != nil) {
			createNode(b, root, nil);
		}
		b.append("}");
		return b.toString();
	}

	private void createNode(StringBuilder b, RedBlackTreeNode n, RedBlackTreeNode nil) {
		String name;
		if (n != nil) {
			name = String.format("node%03d", ++cnt);
			b.append(name + String.format("[label=\"%s\"];\n", n.value));
		} else {
			name = String.format("node%03d", ++cnt);
			b.append(name + "[style=\"invis\"];\n");
		}
		if (n != nil) {
			b.append(String.format("%s->node%03d", name, cnt + 1));
			if (n.left == nil) {
				b.append("[style=\"invis\"]");
			} else if (n.left.red) {
				b.append("[color=red]");
			}
			b.append(";\n");
			createNode(b, n.left, nil);
			b.append(String.format("%s->node%03d", name, cnt + 1));
			if (n.right == nil) {
				b.append("[style=\"invis\"]");
			} else if (n.right.red) {
				b.append("[color=red]");
			}
			b.append(";\n");
			createNode(b, n.right, nil);
		}
	}

}
